#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE block	 	      */
    char   taein[][CMLEN],	/* TAE file names of input images     */
    char   hosin[][CMLEN],  	/* host file names of input image     */
    char   taeout[][CMLEN],	/* TAE file name of output image      */
    char   hosout[][CMLEN],	/* host file name of output image     */
    long   *nmrimg, 		/* number of input images	      */
    long   (*bands)[MAXBND+1],	/* band specification 		      */
    long   *nbands,		/* number of bands per input image    */
    long   (*window)[4],        /* window specification		      */
    long   *msgtim,		/* time between display messages      */
    char   *minmax,		/* min max flag buffer		      */
    char   *subnam,		/* subcommand specified		      */
    long   *xfact,		/* factor to enlarge or reduce the x-axis  */
    long   *yfact,		/* factor to enlarge or reduce the y-axis  */
    long   *nol,		/* number of image output lines       */
    long   *nos,		/* number of image output samples     */
    long   *odtype,		/* data type of input image	      */
    long   *totbnd,		/* total number of bands	      */
    char   distrib[8],		/* distribtion function for random
				   multipliers			      */
    float  coeff[3],		/* Coefficents of distribution function */
    float  range[2],		/* range of multiplier values	      */
    char   select[7],		/* multiplier selection option	      */
    long   *nbin,		/* number of bins in multiplier table */
    long   *seed		/* seed for random number generator   */
);

void zmbldtbl
(
    char	*distrib,	/* Name of distribution function */
    float	coeff[],	/* Coefficients for distribution */
    float	range[2],	/* Minimum and maximum multipliers */
    long	nbin,		/* Number of bins in multiplier table */
    float	multtab[]	/* Table of multipliers */
);

void zmexpand
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char   hosin[][CMLEN],	/* host names of input images		     */
    char   hosout[][CMLEN],		/* host name of output image		     */
    long   nmrimg,			/* number of input images                    */
    long   (*window)[4],		/* window specification of input images      */
    long   (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long   *nbands,		/* number of bands per input image           */
    long   totbnd,		/* total number of bands to be processed     */
    long   odtype,		/* data type of output image                 */
    long   xfact,		/* expansion factor for the x-axis	     */
    long   yfact,		/* expansion factor for the y-axis	     */
    long   msgtim,		/* elapsed time between display messages     */
    char   *minmax,		/* min max flag                              */
    long   nol,			/* number of image output lines              */
    long   nos			/* number of image output samples            */
);

long zmmeanred
(
    struct PARBLK *vblock,	/* TAE parameter block */
    char   hosin[][CMLEN],	/* Host names of input images */
    char hosout[][CMLEN],	/* Host name of output image */
    long   nmrimg,		/* Number of input images */
    long   (*window)[4],	/* Window specification output image */
    long   (*bands)[MAXBND+1], /* Bands for each input image */
    long   *nbands,		/* Number of bands per input image */
    long   totbnd,		/* Total number of input bands */
    long   odtype,		/* Data type of output image */
    long   xfact,		/* Expansion factor for the x-axis */
    long   yfact,		/* Expansion factor for the y-axis */
    long   msgtim,		/* Processing progress message interval */
    char   *minmax		/* Min/max flag */
);

long zmrandex (
    struct PARBLK *vblock,	/* TAE parameter block */
    char   hosin[][CMLEN],	/* Host names of input images */
    char hosout[][CMLEN],	/* Host name of output image */
    long   nmrimg,		/* Number of input images */
    long   (*window)[4],	/* Window specification output image */
    long   (*bands)[MAXBND+1], /* Bands for each input image */
    long   *nbands,		/* Number of bands per input image */
    long   totbnd,		/* Total number of input bands */
    long   odtype,		/* Data type of output image */
    long   xfact,		/* Expansion factor for the x-axis */
    long   yfact,		/* Expansion factor for the y-axis */
    long   msgtim,		/* Processing progress message interval */
    char   *minmax,		/* Min/max flag */
    char   *randfunc,		/* Name of distribution function */
    float  coeff[],		/* Coefficients for distribution */
    float  range[2],		/* Minimum and maximum multipliers */
    char   select[],		/* Multiplier selection option */
    long   nbin,		/* Number of bins in multiplier table */
    long   seed			/* Seed for random number generator */
);

void zmreduce
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char   hosin[][CMLEN],		/* host names of input images		     */
    char   hosout[][CMLEN],		/* host name of output image		     */
    long   nmrimg,			/* number of input images                    */
    long   (*window)[4],		/* window specification of input images      */
    long   (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long   *nbands,		/* number of bands per input image           */
    long   totbnd,		/* total number of bands to be processed     */
    long   odtype,		/* data type of output image                 */
    long   xfact,		/* reduction factor for the x-axis	     */
    long   yfact,		/* reduction factor for the y-axis	     */
    long   msgtim,		/* elapsed time between display messages     */
    char   *minmax,		/* min max flag                              */
    long   nol,			/* number of image output lines		     */
    long   nos			/* number of image output samples            */
);

#endif
